"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const utils_1 = require("./utils");
exports.default = {
    isInstalled() {
        const { code } = (0, utils_1.exec)('xcode-select -p');
        return code === 0;
    },
    download() {
        (0, utils_1.exec)('touch /tmp/.com.apple.dt.CommandLineTools.installondemand.in-progress');
        (0, utils_1.exec)(`softwareupdate -d "${(0, utils_1.memoize)(getLabel)}"`);
    },
    install() {
        (0, utils_1.exec)(`softwareupdate -i "${(0, utils_1.memoize)(getLabel)}"`);
    }
};
function getLabel() {
    const { stdout, code } = (0, utils_1.exec)('softwareupdate -l | grep "*.*Command Line" | head -n 1');
    return code ? '' : stdout.replace('* Label: ', '').trim();
}
