"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
const dmg_1 = __importDefault(require("./unpack/dmg"));
const zip_1 = __importDefault(require("./unpack/zip"));
const pkg_1 = __importDefault(require("./unpack/pkg"));
const mas_1 = __importDefault(require("./unpack/mas"));
const brew_1 = __importDefault(require("./unpack/brew"));
const utils_1 = require("./utils");
async function install(options) {
    const ext = (0, utils_1.extName)(options.filePath);
    if (options.appName.toLowerCase() === 'brew') {
        return await brew_1.default.installer(options.filePath, options.dest);
    }
    if ((0, utils_1.isBrewUrl)(options.filePath)) {
        return brew_1.default.install(options.filePath);
    }
    if (ext === '.zip') {
        return await (0, zip_1.default)(options.filePath, options.dest);
    }
    else if (ext === '.dmg') {
        return await (0, dmg_1.default)(options.filePath, options.dest);
    }
    else if (ext === '.pkg') {
        return await (0, pkg_1.default)(options.filePath, options.dest);
    }
    else if (ext === '.mas') {
        return await (0, mas_1.default)(options.filePath, options.dest);
    }
    else {
        return '';
    }
}
exports.default = install;
