"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const utils_1 = require("../utils");
const path_1 = require("path");
async function unpkg(filePath, dest) {
    const snapshot = utils_1.pkgutil.pkgs();
    await utils_1.pkgutil.installer(filePath, dest);
    return getCurrentPkgs(snapshot, utils_1.pkgutil.pkgs(), dest.replace('/', ''));
}
exports.default = unpkg;
function getCurrentPkgs(previousValue, currentValue, dest) {
    const pkgIds = currentValue.filter((value) => !previousValue.includes(value));
    const pkgInfos = pkgIds.map((pkgid) => utils_1.pkgutil.pkgInfo(pkgid));
    if (pkgIds.length === 0) {
        throw new Error('file already exists');
    }
    if (pkgInfos.map((info) => info['install-location']).includes(dest)) {
        const pkgInfo = pkgInfos.find((info) => info['install-location'] === dest);
        const pkgFiles = pkgInfo ? utils_1.pkgutil.files(pkgInfo.pkgid) : [];
        return (0, path_1.join)(dest, pkgFiles.filter((fileName) => /^[^/]+$/.test(fileName))[0]);
    }
    else {
        return (0, utils_1.which)(pkgInfos.map((info) => (0, path_1.basename)(utils_1.pkgutil.files(info.pkgid)[0]))[0]);
    }
}
