"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
const path_1 = require("path");
const adm_zip_1 = __importDefault(require("adm-zip"));
const decompress_1 = __importDefault(require("decompress"));
async function unzip(filePath, dest) {
    const zip = new adm_zip_1.default(filePath);
    const entry = zip.getEntries().filter((entry) => /\.app\/?$/.test(entry.entryName))[0];
    if (entry) {
        try {
            await (0, decompress_1.default)(filePath, dest);
        }
        catch (error) {
            throw error.code === 'EEXIST' ? new Error('file already exists') : error;
        }
        return (0, path_1.join)(dest, entry.entryName.replace('/', ''));
    }
    return '';
}
exports.default = unzip;
