"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.memoize = exports.isInstalled = exports.tmpdir = exports.isBrewUrl = exports.extName = exports.toInt = exports.APP_DIR = exports.Homebrew_DIR = exports.isAppleCPU = exports.MAS_PKG_URL = exports.execute = exports.which = exports.exec = exports.cp = exports.pkgutil = void 0;
const os_1 = __importDefault(require("os"));
const pkgutil = __importStar(require("./pkgutil"));
exports.pkgutil = pkgutil;
const path_1 = require("path");
const promises_1 = require("fs/promises");
const shell_1 = require("./shell");
Object.defineProperty(exports, "cp", { enumerable: true, get: function () { return shell_1.cp; } });
Object.defineProperty(exports, "exec", { enumerable: true, get: function () { return shell_1.exec; } });
Object.defineProperty(exports, "which", { enumerable: true, get: function () { return shell_1.which; } });
Object.defineProperty(exports, "execute", { enumerable: true, get: function () { return shell_1.execute; } });
const constants_1 = require("./constants");
Object.defineProperty(exports, "MAS_PKG_URL", { enumerable: true, get: function () { return constants_1.MAS_PKG_URL; } });
Object.defineProperty(exports, "isAppleCPU", { enumerable: true, get: function () { return constants_1.isAppleCPU; } });
Object.defineProperty(exports, "Homebrew_DIR", { enumerable: true, get: function () { return constants_1.Homebrew_DIR; } });
Object.defineProperty(exports, "APP_DIR", { enumerable: true, get: function () { return constants_1.APP_DIR; } });
function toInt(text) {
    return text ? parseInt(text, 10) : 0;
}
exports.toInt = toInt;
function extName(filePath) {
    const ext = (0, path_1.extname)(filePath);
    if (ext) {
        return ext;
    }
    else if (/^\d+$/.test(filePath)) {
        return '.mas';
    }
    else {
        return '';
    }
}
exports.extName = extName;
function isBrewUrl(url) {
    return url.slice(0, 4).toLowerCase() === 'brew';
}
exports.isBrewUrl = isBrewUrl;
async function tmpdir() {
    return await (0, promises_1.mkdtemp)((0, path_1.join)(os_1.default.tmpdir(), 'download'));
}
exports.tmpdir = tmpdir;
async function isInstalled(appName) {
    try {
        const filePath = (0, path_1.join)(constants_1.APP_DIR, `${appName}.app`);
        return (await (0, promises_1.lstat)(filePath)).isDirectory() ? filePath : '';
    }
    catch (error) {
        appName = appName.toLowerCase();
        if (appName === 'git') {
            return whichGit();
        }
        else if (appName === 'brew') {
            return whichBrew();
        }
        else {
            return (0, shell_1.which)(appName);
        }
    }
}
exports.isInstalled = isInstalled;
function whichBrew() {
    if ((0, shell_1.which)('brew')) {
        return (0, shell_1.which)('brew');
    }
    else if ((0, shell_1.which)(`${constants_1.Homebrew_DIR}/bin/brew`)) {
        return (0, shell_1.which)(`${constants_1.Homebrew_DIR}/bin/brew`);
    }
    else {
        return '';
    }
}
function whichGit() {
    const { code, stdout } = (0, shell_1.exec)('git version');
    if (code !== 0 || stdout.indexOf('Apple') !== -1) {
        return '';
    }
    else {
        return (0, shell_1.which)('git');
    }
}
function memoize(func, ...args) {
    const cache = memoize;
    if (!cache.hash) {
        cache.hash = new Map();
    }
    if (!cache.hash.has(func)) {
        cache.hash.set(func, func(...args));
    }
    return cache.hash.get(func);
}
exports.memoize = memoize;
