"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.installer = exports.files = exports.pkgInfo = exports.pkgs = void 0;
const plist_1 = __importDefault(require("plist"));
const shell_1 = require("./shell");
function pkgs() {
    const { stdout } = (0, shell_1.exec)('pkgutil --pkgs-plist');
    return stdout ? plist_1.default.parse(stdout.trim()) : [];
}
exports.pkgs = pkgs;
function pkgInfo(pkgid) {
    const { stdout } = (0, shell_1.exec)(`pkgutil --pkg-info-plist ${pkgid}`);
    return stdout ? plist_1.default.parse(stdout.trim()) : {};
}
exports.pkgInfo = pkgInfo;
function files(pkgid) {
    const { stdout } = (0, shell_1.exec)(`pkgutil --files ${pkgid} --only-files`);
    return stdout ? stdout.trim().split('\n') : [];
}
exports.files = files;
function installer(pathToPackage, mountPoint) {
    return (0, shell_1.execute)(`installer -pkg ${convertSpaces(pathToPackage)} -target ${mountPoint}`);
}
exports.installer = installer;
function convertSpaces(filePath) {
    return filePath.replace(/ /g, '\\ ');
}
