"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.which = exports.execute = exports.exec = exports.cp = void 0;
const shelljs_1 = __importDefault(require("shelljs"));
const sudo_prompt_1 = __importDefault(require("sudo-prompt"));
function cp(source, dest) {
    shelljs_1.default.cp('-R', source, dest);
    return dest;
}
exports.cp = cp;
function exec(command, silent = true) {
    return shelljs_1.default.exec(command, { silent });
}
exports.exec = exec;
function execute(command) {
    return new Promise((resolve, reject) => {
        sudo_prompt_1.default.exec(command, (error, stdout, stderr) => {
            if (error) {
                return reject(error);
            }
            resolve({ stdout, stderr });
        });
    });
}
exports.execute = execute;
function which(command) {
    const { stdout = '' } = shelljs_1.default.which(command) || {};
    return stdout;
}
exports.which = which;
